/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arith11_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  return 0;
}

int
pattern19 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC_VOLATILE
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != MINUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
      || pattern10 (x1, 
25, 
2, 
CLOBBER) != 0)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith14_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!pmode_register_operand (operands[0], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!pmode_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!pmode_register_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!pmode_register_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!pmode_register_operand (operands[4], E_VOIDmode))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[3] = x3;
      if (!ordered_comparison_operator (operands[3], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      if (!ordered_comparison_operator (x4, E_SImode))
        return -1;
      operands[6] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!arith11_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[4] = x7;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[5] = x8;
      if (!arith11_operand (operands[5], E_SImode))
        return -1;
      return 6; /* iorscc */

    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          if (!cint_ior_operand (operands[2], E_SImode))
            return -1;
          return 136; /* *pa.md:6015 */

        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 137; /* *pa.md:6024 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern22 (x2) != 0
          || !
#line 6685 "../../gcc/config/pa/pa.md"
(exact_log2 (INTVAL (operands[1]) + 1) > 0))
        return -1;
      return 180; /* vdepi_ior */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!ordered_comparison_operator (operands[2], E_VOIDmode)
      || pattern27 (x1) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!reg_before_reload_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  if (!int5_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[0]))
    return -1;
  x13 = XEXP (x11, 1);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x10, 0);
  if (!rtx_equal_p (x14, operands[0]))
    return -1;
  *pnum_clobbers = 1;
  return 232; /* decrement_and_branch_until_zero */
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case MEM:
          return recog_15 (x1, insn, pnum_clobbers);

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case MEM:
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case PLUS:
                  if (GET_MODE (x5) != E_SImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != SET)
                    return -1;
                  x7 = XEXP (x6, 1);
                  if (GET_CODE (x7) != PLUS
                      || GET_MODE (x7) != E_SImode)
                    return -1;
                  x8 = XEXP (x5, 0);
                  operands[0] = x8;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x9 = XEXP (x5, 1);
                  operands[1] = x9;
                  operands[2] = x3;
                  x10 = XEXP (x7, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return -1;
                  x11 = XEXP (x7, 1);
                  if (!rtx_equal_p (x11, operands[1]))
                    return -1;
                  x12 = XEXP (x6, 0);
                  if (!rtx_equal_p (x12, operands[0]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_SImode:
                      if (!pre_cint_operand (operands[1], E_SImode)
                          || !reg_or_0_operand (operands[2], E_SImode))
                        return -1;
                      return 48; /* *pa.md:2537 */

                    case E_HImode:
                      if (!int5_operand (operands[1], E_SImode)
                          || !reg_or_0_operand (operands[2], E_HImode))
                        return -1;
                      return 64; /* *pa.md:3054 */

                    case E_QImode:
                      if (!int5_operand (operands[1], E_SImode)
                          || !reg_or_0_operand (operands[2], E_QImode))
                        return -1;
                      return 70; /* *pa.md:3228 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[0] = x5;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[1] = x3;
                  x6 = XVECEXP (x1, 0, 1);
                  switch (GET_CODE (x6))
                    {
                    case SET:
                      x7 = XEXP (x6, 1);
                      if (GET_CODE (x7) != PLUS
                          || GET_MODE (x7) != E_SImode
                          || GET_MODE (x4) != E_SImode
                          || !reg_or_0_operand (operands[1], E_SImode))
                        return -1;
                      x11 = XEXP (x7, 1);
                      operands[2] = x11;
                      if (!post_cint_operand (operands[2], E_SImode))
                        return -1;
                      x10 = XEXP (x7, 0);
                      if (!rtx_equal_p (x10, operands[0]))
                        return -1;
                      x12 = XEXP (x6, 0);
                      if (!rtx_equal_p (x12, operands[0]))
                        return -1;
                      return 50; /* post_stw */

                    case CLOBBER:
                      if (GET_MODE (x4) != E_DImode
                          || !reg_or_0_operand (operands[1], E_DImode))
                        return -1;
                      x12 = XEXP (x6, 0);
                      operands[2] = x12;
                      if (!scratch_operand (operands[2], E_DImode)
                          || !
#line 10786 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_SOFT_FLOAT))
                        return -1;
                      return 266; /* atomic_storedi_1 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case PC:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern7 (x6, 
2, 
CLOBBER) != 0)
                return -1;
              operands[0] = x3;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              if (
#line 9124 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && !TARGET_64BIT))
                return 223; /* *pa.md:9121 */
              if (
#line 9132 "../../gcc/config/pa/pa.md"
(TARGET_NO_SPACE_REGS && !TARGET_64BIT))
                return 224; /* *pa.md:9129 */
              return 225; /* *pa.md:9137 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x13 = XEXP (x3, 0);
          if (GET_CODE (x13) != MEM)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x16 = XEXP (x14, 1);
          operands[2] = x16;
          if (!int5_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x7, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x12 = XEXP (x6, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x13))
                {
                case E_HImode:
                  return 63; /* *pa.md:3028 */

                case E_QImode:
                  return 68; /* *pa.md:3184 */

                default:
                  return -1;
                }

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x13) != E_QImode)
                return -1;
              return 69; /* *pa.md:3206 */

            default:
              return -1;
            }

        case PLUS:
          x13 = XEXP (x3, 0);
          switch (GET_CODE (x13))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case REG:
            case SUBREG:
              switch (pattern11 (x1, 
PLUS))
                {
                case 0:
                  if (pattern64 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 119; /* *pa.md:5212 */

                case 1:
                  if (pattern64 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 121; /* addvsi3 */

                case 2:
                  if (!
#line 9909 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpyaddoperands (operands)))
                    return -1;
                  return 241; /* *pa.md:9902 */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x13, 0) != 1)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x12 = XEXP (x6, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 1)
                return -1;
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              x17 = XVECEXP (x13, 0, 0);
              operands[1] = x17;
              x18 = XEXP (x3, 1);
              operands[2] = x18;
              switch (XINT (x13, 1))
                {
                case 6:
                  if (!tld_symbolic_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern55 (x1, 
E_SImode) != 0
                          || !
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                        return -1;
                      return 256; /* tld_offset_loadsi */

                    case E_DImode:
                      if (pattern55 (x1, 
E_DImode) != 0
                          || !
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                        return -1;
                      return 257; /* tld_offset_loaddi */

                    default:
                      return -1;
                    }

                case 9:
                  if (!tle_symbolic_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern55 (x1, 
E_SImode) != 0
                          || !
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                        return -1;
                      return 263; /* tle_loadsi */

                    case E_DImode:
                      if (pattern55 (x1, 
E_DImode) != 0
                          || !
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                        return -1;
                      return 264; /* tle_loaddi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          switch (pattern11 (x1, 
MINUS))
            {
            case 0:
              if (pattern62 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 123; /* *pa.md:5405 */

            case 1:
              if (pattern62 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 126; /* subvsi3 */

            case 2:
              if (!
#line 9957 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpysuboperands (operands)))
                return -1;
              return 243; /* *pa.md:9950 */

            default:
              return -1;
            }

        case MULT:
          if (pnum_clobbers != NULL
              && pattern18 (x1) == 0)
            {
              *pnum_clobbers = 3;
              return 129; /* *pa.md:5634 */
            }
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x13 = XEXP (x3, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_VOIDmode))
            return -1;
          x18 = XEXP (x3, 1);
          operands[2] = x18;
          if (!register_operand (operands[2], E_VOIDmode))
            return -1;
          x12 = XEXP (x6, 0);
          operands[3] = x12;
          if (!register_operand (operands[3], E_VOIDmode))
            return -1;
          x7 = XEXP (x6, 1);
          switch (GET_CODE (x7))
            {
            case PLUS:
              x10 = XEXP (x7, 0);
              operands[4] = x10;
              if (!register_operand (operands[4], E_VOIDmode))
                return -1;
              x11 = XEXP (x7, 1);
              operands[5] = x11;
              if (!register_operand (operands[5], E_VOIDmode)
                  || !
#line 9880 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpyaddoperands (operands)))
                return -1;
              return 240; /* *pa.md:9873 */

            case MINUS:
              x10 = XEXP (x7, 0);
              operands[4] = x10;
              if (!register_operand (operands[4], E_VOIDmode))
                return -1;
              x11 = XEXP (x7, 1);
              operands[5] = x11;
              if (!register_operand (operands[5], E_VOIDmode)
                  || !
#line 9938 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT
   && reload_completed && pa_fmpysuboperands (operands)))
                return -1;
              return 242; /* *pa.md:9931 */

            default:
              return -1;
            }

        case DIV:
          if (pattern12 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 130; /* *pa.md:5758 */

        case UDIV:
          if (pattern12 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 131; /* *pa.md:5807 */

        case MOD:
          if (pnum_clobbers == NULL
              || pattern18 (x1) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 132; /* *pa.md:5854 */

        case UMOD:
          if (pnum_clobbers == NULL
              || pattern18 (x1) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 133; /* *pa.md:5901 */

        case NEG:
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x13 = XEXP (x3, 0);
          switch (GET_CODE (x13))
            {
            case REG:
            case SUBREG:
              operands[1] = x13;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != TRAP_IF)
                return -1;
              x12 = XEXP (x6, 0);
              if (GET_CODE (x12) != NE)
                return -1;
              x19 = XEXP (x12, 0);
              if (GET_CODE (x19) != NEG)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != SIGN_EXTEND)
                return -1;
              x21 = XEXP (x12, 1);
              if (GET_CODE (x21) != SIGN_EXTEND)
                return -1;
              x22 = XEXP (x21, 0);
              if (GET_CODE (x22) != NEG)
                return -1;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x23 = XEXP (x20, 0);
              if (!rtx_equal_p (x23, operands[1]))
                return -1;
              x24 = XEXP (x22, 0);
              if (!rtx_equal_p (x24, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern60 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 140; /* *pa.md:6097 */

                case E_SImode:
                  if (pattern60 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 142; /* negvsi2 */

                default:
                  return -1;
                }

            case ABS:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              switch (pattern33 (x1))
                {
                case 0:
                  if (!
#line 6439 "../../gcc/config/pa/pa.md"
((! TARGET_SOFT_FLOAT && TARGET_PA_20
    && ! reg_overlap_mentioned_p (operands[2], operands[1]))))
                    return -1;
                  return 167; /* *pa.md:6435 */

                case 1:
                  if (!
#line 6458 "../../gcc/config/pa/pa.md"
((! TARGET_SOFT_FLOAT && TARGET_PA_20
    && ! reg_overlap_mentioned_p (operands[2], operands[1]))))
                    return -1;
                  return 168; /* *pa.md:6454 */

                default:
                  return -1;
                }

            case MULT:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              switch (pattern35 (x1))
                {
                case 0:
                  if (!
#line 6499 "../../gcc/config/pa/pa.md"
((!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros
    && ! (reg_overlap_mentioned_p (operands[3], operands[1])
          || reg_overlap_mentioned_p (operands[3], operands[2])))))
                    return -1;
                  return 171; /* *pa.md:6493 */

                case 1:
                  if (!
#line 6523 "../../gcc/config/pa/pa.md"
((!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros
    && ! (reg_overlap_mentioned_p (operands[3], operands[1])
          || reg_overlap_mentioned_p (operands[3], operands[2])))))
                    return -1;
                  return 172; /* *pa.md:6517 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LABEL_REF:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x13 = XEXP (x3, 0);
              operands[1] = x13;
              if (
#line 7298 "../../gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 196; /* lcla1 */
              if (!
#line 7313 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
                return -1;
              return 197; /* lcla2 */

            case PC:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x12 = XEXP (x6, 0);
              operands[0] = x12;
              x7 = XEXP (x6, 1);
              switch (GET_CODE (x7))
                {
                case PLUS:
                  if (GET_MODE (x7) != E_SImode)
                    return -1;
                  x13 = XEXP (x3, 0);
                  operands[3] = x13;
                  if (!ireg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x7, 0);
                  operands[1] = x10;
                  if (!ireg_operand (operands[1], E_SImode))
                    return -1;
                  x11 = XEXP (x7, 1);
                  operands[2] = x11;
                  if (!ireg_or_int5_operand (operands[2], E_SImode)
                      || !
#line 9762 "../../gcc/config/pa/pa.md"
((reload_completed && operands[0] == operands[1]) || operands[0] == operands[2]))
                    return -1;
                  return 235; /* *pa.md:9757 */

                case CONST_INT:
                case REG:
                  operands[1] = x7;
                  x13 = XEXP (x3, 0);
                  operands[2] = x13;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SFmode:
                      if (!ireg_operand (operands[0], E_SFmode)
                          || !ireg_or_int5_operand (operands[1], E_SFmode)
                          || !
#line 9785 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 236; /* *pa.md:9781 */

                    case E_SImode:
                      if (!ireg_operand (operands[0], E_SImode)
                          || !ireg_or_int5_operand (operands[1], E_SImode)
                          || !
#line 9808 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 237; /* *pa.md:9804 */

                    case E_HImode:
                      if (!ireg_operand (operands[0], E_HImode)
                          || !ireg_or_int5_operand (operands[1], E_HImode)
                          || !
#line 9831 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 238; /* *pa.md:9827 */

                    case E_QImode:
                      if (!ireg_operand (operands[0], E_QImode)
                          || !ireg_or_int5_operand (operands[1], E_QImode)
                          || !
#line 9854 "../../gcc/config/pa/pa.md"
(reload_completed))
                        return -1;
                      return 239; /* *pa.md:9850 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x13 = XEXP (x3, 0);
          switch (GET_CODE (x13))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              if (pnum_clobbers != NULL)
                {
                  res = recog_14 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (!movb_comparison_operator (x13, E_VOIDmode))
                return -1;
              operands[2] = x13;
              x25 = XEXP (x13, 1);
              if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) != PC)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x14 = XEXP (x13, 0);
              operands[1] = x14;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x12 = XEXP (x6, 0);
              operands[0] = x12;
              if (!reg_before_reload_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x6, 1);
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              x18 = XEXP (x3, 1);
              switch (GET_CODE (x18))
                {
                case LABEL_REF:
                  x26 = XEXP (x3, 2);
                  if (GET_CODE (x26) != PC)
                    return -1;
                  x27 = XEXP (x18, 0);
                  operands[3] = x27;
                  return 233; /* *pa.md:9614 */

                case PC:
                  x26 = XEXP (x3, 2);
                  if (GET_CODE (x26) != LABEL_REF)
                    return -1;
                  x28 = XEXP (x26, 0);
                  operands[3] = x28;
                  return 234; /* *pa.md:9686 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (XINT (x3, 1))
            {
            case 0:
              if (pnum_clobbers == NULL
                  || pattern39 (x3) != 0)
                return -1;
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) != REG
                  || REGNO (x4) != 29
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x12 = XEXP (x6, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 3;
              return 250; /* *$$sh_func_adrs */

            case 13:
              if (GET_MODE (x3) != E_BLKmode)
                return -1;
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              if (!pmode_register_operand (operands[1], E_VOIDmode))
                return -1;
              x29 = XVECEXP (x3, 0, 0);
              if (!rtx_equal_p (x29, operands[0]))
                return -1;
              if (
#line 10824 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && TARGET_COHERENT_LDCW))
                return 267; /* *memory_barrier_coherent */
              return 268; /* *memory_barrier_32 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern7 (x6, 
2, 
USE) != 0)
        return -1;
      if (
#line 7202 "../../gcc/config/pa/pa.md"
(pa_can_use_return_insn ()))
        return 192; /* return */
      return 193; /* return_internal */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET
          || pattern36 (x6) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (!call_operand_address (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x7 = XEXP (x6, 1);
      x11 = XEXP (x7, 1);
      x30 = XEXP (x11, 0);
      operands[2] = x30;
      if (!
#line 8783 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 217; /* call_mcount_nonpic */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 7)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x31 = XVECEXP (x2, 0, 0);
      operands[0] = x31;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!scratch_operand (operands[1], E_SImode)
          || !
#line 10915 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_64BIT))
        return -1;
      return 270; /* set_fpsr_32 */

    default:
      return -1;
    }
}
