/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, unsigned int i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern9 (x4, 
i2, 
i3); /* [-1, 0] */
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 29
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!r26_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[0] = x7;
  if (!r25_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 19
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!reg_or_cint_move_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!arith11_operand (operands[4], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          operands[2] = x5;
          return 28; /* *pa.md:1274 */
        }
      operands[5] = x5;
      operands[2] = x8;
      if (!reg_or_cint_move_operand (operands[2], E_SImode))
        return -1;
      return 29; /* *pa.md:1291 */

    case LABEL_REF:
      if (pattern13 (x1, 
PC) != 0)
        return -1;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      return 30; /* *pa.md:1423 */

    case PC:
      if (pattern13 (x1, 
LABEL_REF) != 0)
        return -1;
      x8 = XEXP (x2, 2);
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      return 31; /* *pa.md:1452 */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 4940 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 99; /* *pa.md:4937 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 4959 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 101; /* *pa.md:4956 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern15 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 4948 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 100; /* floatsisf2 */

            case 1:
              if (!
#line 5011 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 103; /* floatdisf2 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern15 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 4967 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 102; /* floatsidf2 */

            case 1:
              if (!
#line 5019 "../../gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 104; /* floatdidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != 0L)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != USE)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != USE)
            return -1;
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_SImode)
              || pattern40 (x1) != 0)
            return -1;
          return 73; /* clrmemsi_prereload */

        case MULT:
          if (pattern24 (x1) != 0)
            return -1;
          return 129; /* *pa.md:5634 */

        case DIV:
          if (pattern25 (x1) != 0)
            return -1;
          return 130; /* *pa.md:5758 */

        case UDIV:
          if (pattern25 (x1) != 0)
            return -1;
          return 131; /* *pa.md:5807 */

        case MOD:
          if (pattern24 (x1) != 0)
            return -1;
          return 132; /* *pa.md:5854 */

        case UMOD:
          if (pattern24 (x1) != 0)
            return -1;
          return 133; /* *pa.md:5901 */

        case CALL:
          x10 = XEXP (x5, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_SImode)
            return -1;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 1
              || GET_MODE (x11) != E_SImode
              || pattern45 (x1, 
USE, 
2) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          x12 = XEXP (x7, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 19
              || GET_MODE (x12) != E_SImode)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != USE)
            return -1;
          x13 = XEXP (x8, 0);
          if (GET_CODE (x13) != CONST_INT)
            return -1;
          switch (pattern49 (x2))
            {
            case 0:
              if (XWINT (x13, 0) != 0L)
                return -1;
              x14 = XEXP (x5, 1);
              operands[2] = x14;
              if (!
#line 8270 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 213; /* *call_val_symref_pic_post_reload */

            case 1:
              if (XWINT (x13, 0) != 1L)
                return -1;
              x14 = XEXP (x5, 1);
              operands[1] = x14;
              return 216; /* *call_val_reg_pic_post_reload */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 0
              || pattern39 (x5) != 0)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 29
              || GET_MODE (x6) != E_SImode
              || pattern53 (x1, 
31, 
22, 
26) != 0)
            return -1;
          x11 = XEXP (x3, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 250; /* *$$sh_func_adrs */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (pattern9 (x4, 
2, 
CLOBBER) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != USE)
        return -1;
      x9 = XEXP (x6, 0);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[0] = x9;
          if (!call_operand_address (operands[0], E_VOIDmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x3 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x3))
            {
            case CLOBBER:
              if (pattern54 (x1, 
0) != 0
                  || !
#line 7756 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 207; /* *call_symref_pic_post_reload */

            case SET:
              if (pattern36 (x3) != 0
                  || pattern66 (x1) != 0)
                return -1;
              x15 = XEXP (x3, 1);
              x16 = XEXP (x15, 1);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              x7 = XVECEXP (x1, 0, 3);
              x12 = XEXP (x7, 0);
              operands[3] = x12;
              if (!
#line 8802 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                return -1;
              return 218; /* call_mcount_pic */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x9) != 22
              || GET_MODE (x9) != E_SImode)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER
              || pattern54 (x1, 
1) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          operands[0] = x5;
          return 210; /* *call_reg_pic_post_reload */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL
          || XWINT (x2, 0) != 1L
          || pattern20 (x1, 
1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x18 = XEXP (x4, 0);
      operands[0] = x18;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x1, 0, 3);
      x12 = XEXP (x7, 0);
      operands[1] = x12;
      if (!pmode_register_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      x13 = XEXP (x8, 0);
      operands[2] = x13;
      if (!pmode_register_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
        {
          *pnum_clobbers = 1;
          return 244; /* dcacheflushsi */
        }
      if (!
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
        return -1;
      *pnum_clobbers = 1;
      return 245; /* dcacheflushdi */

    default:
      return -1;
    }
}
